package com.dky.security;

import cn.hutool.core.util.StrUtil;
import cn.hutool.crypto.asymmetric.KeyType;
import cn.hutool.crypto.asymmetric.SM2;
import org.bouncycastle.jce.provider.BouncyCastleProvider;

import javax.crypto.Cipher;
import javax.crypto.spec.SecretKeySpec;
import java.nio.charset.StandardCharsets;
import java.security.Security;
import java.util.Base64;
import java.util.HashMap;
import java.util.Map;

public class SM4Utils {
    static {
        Security.addProvider(new BouncyCastleProvider());
    }

    public final static String SM4_KEY = "dfd2b0581fc9244e51100c5cf02defc8064a45686eb2e4ddfd44cdab2ef908b2";

    private static final String ALGORITHM = "AES/ECB/PKCS5Padding";

    public static String encrypt(Map<String, String> map) throws Exception {

        Cipher cipher = Cipher.getInstance(ALGORITHM, "BC");
        SecretKeySpec secretKey = new SecretKeySpec(SM4_KEY.getBytes(StandardCharsets.UTF_8), "AES");
        cipher.init(Cipher.ENCRYPT_MODE, secretKey);
        byte[] encrypted = cipher.doFinal(mapToString(map).getBytes(StandardCharsets.UTF_8));
        return Base64.getEncoder().encodeToString(encrypted);
    }


    private static String mapToString(Map<String, String> map) {
        StringBuilder sb = new StringBuilder();
        for (Map.Entry<String, String> entry : map.entrySet()) {
            sb.append(entry.getKey()).append('=').append(entry.getValue()).append('&');
        }
        return sb.toString();
    }

    private static Map<String, String> stringToMap(String str) {
        Map<String, String> map = new HashMap<>();
        String[] entries = str.split("&");
        for (String entry : entries) {
            String[] keyValue = entry.split("=", 2);
            if (keyValue.length == 2) {
                map.put(keyValue[0], keyValue[1]);
            }
        }
        return map;
    }


    /**
     * SM2私钥解密
     *
     * @param encryptStr SM2加密字符串
     * @return
     */
    public static String sm2DecryptBase64(String encryptStr) {
        try {
            SM2 sm2 = new SM2(SM4_KEY, null);
            return StrUtil.utf8Str(sm2.decrypt(encryptStr, KeyType.PrivateKey));
        } catch (Exception e) {
            e.printStackTrace();
            System.err.println("密钥错误，请检查密钥输入是否正确");
        }
        return null;
    }

}